SystemOrganization addCategory: #DBXDatabaseModel!

!DBXMySQLBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/9/2011 01:49'!
foreignKeysQuery: aTableName
	^'SELECT kcu.constraint_name AS name, 
			kcu.column_name AS column_name, 
			kcu.referenced_table_name AS foreign_table_name, 
			kcu.referenced_column_name AS foreign_column_name 
	FROM information_schema.KEY_COLUMN_USAGE kcu
	WHERE REFERENCED_TABLE_NAME = ''{1}'';' format: { aTableName }! !

!DBXMySQLBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 9/27/2011 14:24'!
int
	^'int'! !

!DBXOracleBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/12/2011 04:43'!
allTableNamesQuery
	^'SELECT table_name FROM all_tables'! !

!DBXOracleBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/12/2011 05:30'!
foreignKeysQuery: aTableName
	^'SELECT c.constraint_name name, a.column_name column_name, uc.table_name foreign_table_name, uc.column_name foreign_column_name
	FROM user_cons_columns a
	JOIN user_constraints c ON a.owner = c.owner
	AND a.constraint_name = c.constraint_name
	JOIN user_constraints c_pk ON c.r_owner = c_pk.owner
	AND c.r_constraint_name = c_pk.constraint_name
	join USER_CONS_COLUMNS uc on uc.constraint_name = c.r_constraint_name
	WHERE  a.table_name=''{1}''' format: { aTableName asUppercase }.! !

!DBXOracleBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/12/2011 05:36'!
int
	^'NUMBER'! !

!DBXOracleBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/12/2011 05:41'!
stringToBool: aBooleanString
	^aBooleanString = 'Y'! !

!DBXOracleBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/12/2011 05:30'!
tableDescriptionQuery: aTableName
	^'SELECT column_name as name, data_type as type, char_length as length, nullable as is_nullable FROM user_tab_columns where table_name like ''%{1}%''' format: { aTableName asUppercase }! !

!DBXBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 11/4/2011 15:46'!
addColumnsToTable: aTable on: aConnection
	| rs |
	rs := aConnection execute: (self tableDescriptionQuery: aTable name).
	rs rowsDo: [:aRow | 
			aTable
				addColumn: (aRow rawValueNamed: 'name')  
				ofType: (aRow rawValueNamed: 'type') 
				withLength: (self columnLengthForRow: aRow)
				nullable: (self stringToBool: (aRow rawValueNamed: self columnNullableColumnName ))].
! !

!DBXBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 11/4/2011 15:45'!
addForeignKeysToTable: aTable on: aConnection
	| rs |
	rs := aConnection execute: (self foreignKeysQuery: aTable name).
	rs rowsDo: [ :aRow | 
			aTable addComponentToForeignKey: (aRow rawValueNamed: 'name')
				foreignTable: (aRow rawValueNamed: 'foreign_table_name')
				foreignColumn: (aRow rawValueNamed: 'foreign_column_name')
				column: (aRow rawValueNamed: 'column_name')
	].! !

!DBXBackend methodsFor: '*dbxdatabasemodel' stamp: 'GiselaDecuzzi 5/30/2011 02:51'!
allTableNamesQuery
	"SQL to obtain all the table name from the database. This is the ANSI SQL, if the database does not support this should be overwrited"
	^'SELECT * FROM INFORMATION_SCHEMA.TABLES'
	! !

!DBXBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 9/28/2011 02:07'!
columnLengthForRow: aDBXRow
	^aDBXRow rawValueNamed: 'length'! !

!DBXBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 9/27/2011 15:14'!
columnNullableColumnName
	^'is_nullable'! !

!DBXBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/9/2011 02:32'!
foreignKeysQuery: tableName
	"SQL to obtain all the foreign keys from the given tableName database. This is the ANSI SQL, if the database does not support this should be overwrited"
	^ 'SELECT tc.constraint_name AS name, 
			kcu.column_name AS column_name, 
			ccu.table_name AS foreign_table_name, 
			ccu.column_name AS foreign_column_name 
	FROM information_schema.table_constraints AS tc 
	JOIN information_schema.key_column_usage AS kcu ON tc.constraint_name = kcu.constraint_name 
	JOIN information_schema.constraint_column_usage AS ccu ON ccu.constraint_name = tc.constraint_name 
	WHERE constraint_type = ''FOREIGN KEY'' AND tc.table_name=''{1}''' format: { tableName} .
	! !

!DBXBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 9/27/2011 14:24'!
int
	^'integer'! !

!DBXBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/12/2011 05:41'!
stringToBool: aBooleanString
	^aBooleanString ~= 'NO'! !

!DBXBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/29/2011 17:00'!
tableDescription: tableName on: connection
	"returns the description for the tableName "
	| tableDescription rs |
	tableDescription := DBXTable new name: tableName;yourself .
	self addColumnsToTable: tableDescription on: connection.
	self addForeignKeysToTable: tableDescription on: connection.
	^tableDescription.! !

!DBXBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/9/2011 00:48'!
tableDescriptionQuery: tableName
	"SQL to obtain the table description from the database. This is the ANSI SQL, if the database does not support this should be overwrited"
	^'SELECT column_name as name, is_nullable, data_type as type, character_maximum_length as length FROM information_schema.COLUMNS WHERE table_name=''' , tableName, '''' .
	! !

!DBXBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/12/2011 04:53'!
tablesDescription: connection
	"Returns a collection  with all the database tables descripted"
	|rs tablesNames|
	rs := self executeStatement: self allTableNamesQuery on: connection.  
	tablesNames := rs rows collect: [ :aRow | aRow rawValueNamed: 'table_name' ].
	rs releaseResult .
	^tablesNames collect: [ :tableName | self tableDescription: tableName on: connection ].! !

!DBXSqliteBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 9/27/2011 15:05'!
allTableNamesQuery
	"SQL to obtain all the table name from the database. This is the ANSI SQL, if the database does not support this should be overwrited"
	^'SELECT name as table_name FROM sqlite_master
		WHERE type=''table''
		ORDER BY name;'
	! !

!DBXSqliteBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 9/28/2011 02:08'!
columnLengthForRow: aDBXRow
	^nil! !

!DBXSqliteBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 9/27/2011 15:15'!
columnNullableColumnName
	^'notnull'! !

!DBXSqliteBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 10/9/2011 01:58'!
foreignKeysQuery: aTableName
	^'Pragma foreign_key_list(''{1}'')' format: { aTableName }! !

!DBXSqliteBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 9/27/2011 15:17'!
stringToBool: aBooleanString
	^aBooleanString ~= '0'! !

!DBXSqliteBackend methodsFor: '*dbxdatabasemodel' stamp: 'GuillermoPolito 9/27/2011 15:10'!
tableDescriptionQuery: aTableName
	^'Pragma table_info(' , aTableName, ')'! !

Object subclass: #DBXColumn
	instanceVariableNames: 'name nullable type length table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXDatabaseModel'!

!DBXColumn methodsFor: 'accessing' stamp: 'GuillermoPolito 11/4/2011 18:10'!
bePrimaryKey
	table addPrimaryKeyColumn: self.! !

!DBXColumn methodsFor: 'accessing' stamp: 'GuillermoPolito 10/6/2011 20:46'!
constraintsForCreate
	^self nullable ifTrue: ['']  ifFalse: [ 'NOT NULL'].! !

!DBXColumn methodsFor: 'accessing' stamp: 'GuillermoPolito 10/6/2011 20:44'!
generateSQLForCreateTable
	"should generate something like:   FOO INT NOT NULL"
	^   '{1} {2} {3}' format: {self name. self typeForCreate. self constraintsForCreate }! !

!DBXColumn methodsFor: 'testing' stamp: 'GuillermoPolito 10/9/2011 00:46'!
isForeignKey
	^self table isForeignKey: self.! !

!DBXColumn methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:49'!
length
	^ length! !

!DBXColumn methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/22/2011 13:09'!
length: anInteger
	self type length: anInteger.! !

!DBXColumn methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:49'!
name
	^ name! !

!DBXColumn methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:51'!
name: aString
	name := aString ! !

!DBXColumn methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:49'!
nullable
	^ nullable! !

!DBXColumn methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:51'!
nullable: aBoolean
	nullable := aBoolean ! !

!DBXColumn methodsFor: 'accessing' stamp: 'GuillermoPolito 11/4/2011 17:41'!
table: aTable
	table := aTable! !

!DBXColumn methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/22/2011 13:09'!
type
	type ifNil: [ type := DBXColumnType new].
	^ type.! !

!DBXColumn methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/22/2011 13:12'!
type: aTypeName
	" type receives a database type name such as varchar char int etc"
	self type typeName: aTypeName.! !

!DBXColumn methodsFor: 'accessing' stamp: 'GuillermoPolito 11/1/2011 23:25'!
typeForCreate
	^self type typeString! !

!DBXColumn methodsFor: 'accessing' stamp: 'GuillermoPolito 11/1/2011 23:28'!
typeName
	^self type typeName! !

Object subclass: #DBXColumnCluster
	instanceVariableNames: 'columns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXDatabaseModel'!

!DBXColumnCluster class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/29/2011 12:37'!
baseDescription
	^ MAContainer new.! !

!DBXColumnCluster methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/29/2011 12:36'!
add: aColumn
	self columns add: aColumn.! !

!DBXColumnCluster methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/29/2011 12:36'!
columns
	^ columns.! !

!DBXColumnCluster methodsFor: 'initialize-release' stamp: 'SantiagoBragagnolo 10/29/2011 12:36'!
initialize 
	super initialize.
	columns := Set new.! !

DBXColumnCluster subclass: #DBXPrimaryKey
	instanceVariableNames: 'column table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXDatabaseModel'!

!DBXPrimaryKey class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/29/2011 12:04'!
baseDescription
	^ MAContainer new.! !

!DBXPrimaryKey class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:51'!
forColumn: aColumn
	^self new
		column: aColumn;
		yourself ! !

!DBXPrimaryKey class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:53'!
forColumn: aColumn table: aTable
	^self new
		column: aColumn;
		table: aTable;
		yourself ! !

!DBXPrimaryKey methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:52'!
column: aColumn
	column := aColumn! !

!DBXPrimaryKey methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 18:09'!
columnName
	^column name! !

!DBXPrimaryKey methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:53'!
table: aTable
	table := aTable! !

DBXColumnCluster subclass: #DBXUnique
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXDatabaseModel'!

Object subclass: #DBXColumnType
	instanceVariableNames: 'typeName length'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXDatabaseModel'!

!DBXColumnType class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/22/2011 13:06'!
for: aTypeName
	^self new; 
	 typeName: aTypeName; 
	 yourself.! !

!DBXColumnType class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/22/2011 13:07'!
for: aTypeName and:aLength
	^(self for:aTypeName) 
	   length: aLength; 
	   yourself.! !

!DBXColumnType class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2011 20:43'!
fromSymbolArray: aSymbolArray
	| instance |
	instance := self new. 
	instance typeName: (aSymbolArray at:1).
	instance length: (aSymbolArray at:2).
	^ instance.
	
! !

!DBXColumnType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2011 20:33'!
asSymbol 
	| data |
	data := OrderedCollection new.
	data add: typeName.
	data add: length.
	^ data asArray.! !

!DBXColumnType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/6/2011 15:16'!
descriptionTuple
	^#( self typeName asSymbol self length asSymbol).! !

!DBXColumnType methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 15:55'!
gotLength
	^ (self length isNil or: self length == 0) not! !

!DBXColumnType methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 15:55'!
invokeOn: aResolver
	( self gotLength ) ifTrue: [ 
			^aResolver perform: self typeSelector with: self length 
	] ifFalse: [ 
			^aResolver perform: self typeSelector
	]! !

!DBXColumnType methodsFor: 'accessing' stamp: 'GuillermoPolito 11/1/2011 23:26'!
length
	^ length! !

!DBXColumnType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/22/2011 13:13'!
length: aLength 
	length := aLength.! !

!DBXColumnType methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 15:59'!
standarize: aTypeName
	^aTypeName = 'character varying' ifTrue: [ 'varchar' ] ifFalse: [ aTypeName ]! !

!DBXColumnType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/22/2011 13:12'!
typeName
	^typeName! !

!DBXColumnType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/22/2011 13:12'!
typeName: aTypeName
	typeName := self standarize: aTypeName.! !

!DBXColumnType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/22/2011 13:05'!
typeSelector
	^self gotLength ifTrue: [
		(self typeName,':') asSymbol.
	] ifFalse: [
		self typeName asSymbol.
	]! !

!DBXColumnType methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:14'!
typeString
	| lenStr |
	lenStr := self gotLength ifTrue: [ '(', self length asString , ')' ] ifFalse: [ '' ].
	^self typeName, lenStr ! !

Object subclass: #DBXForeignKey
	instanceVariableNames: 'foreignTableName foreignColumnName tableName columnName name components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXDatabaseModel'!

!DBXForeignKey class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/29/2011 13:24'!
baseDescription
	^ MARelationDescription new.! !

!DBXForeignKey class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/29/2011 17:59'!
named: aName
	^self new
		name: aName;
		yourself! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/29/2011 18:16'!
addComponentFromColumn: aColumnName toColumn: aForeignColumnName
	components at: aColumnName put: aForeignColumnName! !

!DBXForeignKey methodsFor: 'accessing' stamp: 'GuillermoPolito 10/29/2011 18:36'!
components
	^ components! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:12'!
destinyColumns
	^components values! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/2/2011 04:33'!
foreignColumnForColumn: aColumn
	^components at: aColumn name! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GiselaDecuzzi 9/26/2011 20:42'!
foreignTable: tableName 
	foreignTableName := tableName .! !

!DBXForeignKey methodsFor: 'accessing' stamp: 'GuillermoPolito 11/2/2011 04:39'!
foreignTableName
	^foreignTableName! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:21'!
generateSQLForCreateTable
	^'CONSTRAINT {1} FOREIGN KEY ({2}) REFERENCES {3} ({4})' format: {
		name.
		',' join: self sourceColumns.
		foreignTableName.
		',' join: self destinyColumns.
	}! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/29/2011 18:15'!
initialize
	components := Dictionary new! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/2/2011 04:15'!
isForColumn: aColumn
	^components includesKey: aColumn name! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GiselaDecuzzi 9/26/2011 20:50'!
name: fkName 
	name := fkName ! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:12'!
sourceColumns
	^components keys! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/29/2011 18:02'!
toTable:  aForeignTableName
	self foreignTable: aForeignTableName.! !

Object subclass: #DBXTable
	instanceVariableNames: 'name columns foreignKeys primaryKeyColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXDatabaseModel'!

!DBXTable class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/2/2011 02:09'!
named: aTableName
	^self new
		name: aTableName;
		yourself! !

!DBXTable methodsFor: 'building' stamp: 'GuillermoPolito 11/4/2011 17:39'!
addColumn: columnName ofType: typeName
	^self addColumn: columnName ofType: typeName withLength: nil! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:39'!
addColumn: anAttributeName ofType: aType withLength: aLen
	^self addColumn: anAttributeName
		ofType: aType
		withLength: aLen
		nullable: false! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:41'!
addColumn: anAttributeName ofType: aType withLength: aLen nullable: aBool
	| attribute |
	attribute := DBXColumn new.
	attribute 
		name: anAttributeName; 
		type: aType;
		length: aLen;
		nullable: aBool.    
	columns add: attribute.
	attribute table: self.
	^attribute! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/2/2011 02:40'!
addComponentToForeignKey: fkName foreignTable: foreignTableName foreignColumn: foreignColumnName column: columnName
	(self foreignKeyNamed: fkName)
		toTable: foreignTableName;
		addComponentFromColumn: columnName
		toColumn: foreignColumnName! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:53'!
addPrimaryKeyColumn: aColumn
	primaryKeyColumns add: (DBXPrimaryKey forColumn: aColumn table: self)! !

!DBXTable methodsFor: 'accessing' stamp: 'GuillermoPolito 10/8/2011 17:15'!
columns
	^ columns! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/8/2011 17:15'!
columnsDo: aBlock
	columns do: aBlock.! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/2/2011 04:31'!
foreignKeyForColumn: aColumn
	^foreignKeys detect: [ :fk | fk isForColumn: aColumn ]! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/29/2011 18:01'!
foreignKeyNamed: fkName
	^foreignKeys detect: [ :fk | fk name = fkName ] 
		ifNone: [ 
			| fk |
			fk := DBXForeignKey named: fkName. 
			foreignKeys add: fk.
			fk "return created foreign key"
			]! !

!DBXTable methodsFor: 'accessing' stamp: 'GuillermoPolito 10/29/2011 18:32'!
foreignKeysDo: anAction
	foreignKeys do: anAction! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 18:13'!
generateCreateTable
	| columnsSql template |
	template := 'CREATE TABLE {1} ( {2} )'.
	columnsSql := ', ' join: ((columns asOrderedCollection , foreignKeys asOrderedCollection) collect: #generateSQLForCreateTable ).
	primaryKeyColumns ifNotEmpty: [ columnsSql := columnsSql ,  ', ' , self primaryKeySQLForCreateTable ].
	^template format: {self name . columnsSql }! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/13/2011 23:02'!
generateDropTable
	^  ' DROP TABLE {1} ' format: { self name }.! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 17:45'!
initialize 
	columns := Set new.
	foreignKeys := Set new.
	primaryKeyColumns := Set new.! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/14/2011 02:19'!
isForeignKey: aColumn 
	^foreignKeys anySatisfy: [ :fk | fk isForColumn: aColumn ].! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/20/2011 17:41'!
name
	^name! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/20/2011 17:41'!
name:aName
	name := aName .! !

!DBXTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 18:11'!
primaryKeySQLForCreateTable
	| template |
	template := 'CONSTRAINT {1} PRIMARY KEY ({2})'.
	columns := ',' join: (primaryKeyColumns collect: #columnName).
	^template format:{ 'pk_', self name . columns }! !
